// Tree.h -- a tree object, subclass and formed of Branches

#import <3Dkit/3Dkit.h>
#import "Branch.h"
#import "ForestCamera.h"

id globalShader;

@interface Tree:Branch
{	
	 // generation parameters for the tree
	float angle, SDangle;
	float twist, SDtwist;
	float shrink, SDshrink;
	int branchFactor, levels;
	float SDbranchFactor, SDlevels;

	 // control of the displaying
	int lastSeed;
	int random_mode;		// 1=constant

	id forest;
}

// set and read tree generation parameters:
	- (double) angle;
	- (double) angle :(double)angleArg;
	- (double) twist;
	- (double) twist :(double)twistArg;
	- (double) shrink;
	- (double) shrink :(double)shrinkArg;
	- (int) branchFactor;
	- (int) branchFactor :(int)branchFactorArg;
	- (int) levels;
	- (int) levels :(int)levelsArg;

	- (double) SDangle;
	- (double) SDangle :(double)SDangleArg;
	- (double) SDtwist;
	- (double) SDtwist :(double)SDtwistArg;
	- (double) SDshrink;
	- (double) SDshrink :(double)SDshrinkArg;
	- (double) SDbranchFactor;
	- (double) SDbranchFactor :(double)SDbranchFactorArg;
	- (double) SDlevels;
	- (double) SDlevels :(double)SDlevelsArg;

// set up trees
	- plantIn :(ForestCamera *)forest;
	- specis :sender;
	- (int) inzVars :(int) index;
	- randomMode :sender;
	- (float) randVal :(treeParameter) param;

@end
